//--------------------------------------------------------------------------
//  Copyright (c) 1996 Next Software, Inc., All Rights Reserved
//
//  No part of this code may be reproduced in any form, compiled
//  or source code, nor used for any purpose without the express
//  written permission of the copyright holder.
//
//  $Id: SCMFileStatus.h,v 1.1 1997/01/24 20:21:21 mmonegan Exp $
//--------------------------------------------------------------------------

#import <AppKit/AppKit.h>

@class SCMAdaptor;

@interface SCMFileStatus : NSObject
{
    NSString        *filename;
    NSString        *wrapperName;
    SCMAdaptor      *adaptor;
    int             status;
}

- (id) initWithFilename: (NSString *) filename adaptor: (SCMAdaptor *) adaptor;
+ (id) fileStatusWithFilename: (NSString *) filename
    adaptor: (SCMAdaptor *) adaptor;

- (NSString *) filename;
- (NSString *) status;
- (SCMAdaptor *) adaptor;

- (NSComparisonResult) compare: (SCMFileStatus *) otherObject;

- (void) restoreFromDictionary: (NSDictionary *) dict;
- (NSMutableDictionary *) objectAsDictionary;

- (NSString *) wrapperName;

@end

@interface SCMFileStatus (Private)

- (void) setStatusOr: (int) bits;
- (void) setStatusAnd: (int) bits;
- (void) setStatusBits: (int) value;
- (int) statusBits;

@end

// statuses

#define SCMS_NO_BITS            0x0000
#define SCMS_ALL_BITS           0xffff

#define SCMS_NEEDS_UPDATE       0x0001
#define SCMS_ADDED          	0x0002
#define SCMS_REMOVED            0x0004
#define SCMS_MODIFIED           0x0010
#define SCMS_LOCKED         	0x0020
#define SCMS_LOCKED_BY_OTHERS  	0x0040
#define SCMS_CONFLICT           0x0100
#define SCMS_UNKNOWN            0x0200
#define SCMS_HIDDEN         	0x0400
#define SCMS_WRAPPER            0x1000

